<?php

class context_condition_author extends context_condition {
  function condition_values() {
    return array();
  }

  /**
   * Condition form.
   */
  function condition_form($context) {
    $form = parent::condition_form($context);
    unset($form['#options']);

    $form['#type'] = 'textarea';
    $form['#default_value'] = implode("\n", $this->fetch_from_context($context, 'values'));
    return $form;
  }

  /**
   * Condition form submit handler.
   */
  function condition_form_submit($values) {
    $parsed = array();
    $items = explode("\n", $values);
    if (!empty($items)) {
      foreach ($items as $v) {
        $v = trim($v);
        if (!empty($v)) {
          $parsed[$v] = $v;
        }
      }
    }
    return $parsed;
  }
  
  // @Note: This was copied exactly from context_condition_node.inc
  function options_form($context) {
    $defaults = $this->fetch_from_context($context, 'options');
    return array(
      'node_form' => array(
        '#title' => t('Set on node form'),
        '#type' => 'select',
        '#options' => array(
           CONTEXT_NODE_VIEW => t('No'),
           CONTEXT_NODE_FORM => t('Yes'),
           CONTEXT_NODE_FORM_ONLY => t('Only on node form')
        ),
        '#description' => t('Set this context on node forms'),
        '#default_value' => isset($defaults['node_form']) ? $defaults['node_form'] : TRUE,
      ),
    );
  }

  function execute($uid) {
    if ($this->condition_used()) {
      foreach ($this->get_contexts() as $context) {
        $users = $this->fetch_from_context($context, 'values');
        $user_ids = $this->convert_to_uids($users);
        if (in_array($uid, $user_ids)) {
          $this->condition_met($context);
        }
      }
    }
  }

  /**
   * Convert the list of users to be all UIDs.
   */
  function convert_to_uids($users) {
    global $user;
    $user_ids = array();
    $usernames = array();
    foreach ($users as $user_id) {
      if (is_numeric($user_id)) {
        $user_ids[] = $user_id;
      }
      if ($user_id == '<current_user>') {
        $user_ids[] = $user->uid;
        continue;
      }
      // The rest will be user names
      $usernames[] = $user_id;
    }

    if (!empty($usernames)) {
      $result = db_query("SELECT uid FROM {users} WHERE name IN (" . implode(', ', array_fill(0, count($usernames), "'%s'")) . ")", $usernames);
      while ($row = db_fetch_object($result)) {
        $user_ids[] = $result->uid;
      }
    }
    return $user_ids;
  }
}
